package pl.edu.amu.wmi.bookapi.exceptions;

import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;

@ControllerAdvice
public class ExceptionHandlerFilter {
  @ExceptionHandler(RegisterException.class) public ResponseEntity handleDuplicateUserName() {
      return ResponseEntity
              .status(HttpStatus.BAD_REQUEST)
              .body("Cannot use this username");
  }

  @ExceptionHandler(NoEanCodeDetectedException.class) public ResponseEntity handleNoEan() {
      return ResponseEntity
              .status(HttpStatus.UNPROCESSABLE_ENTITY)
              .body("Item created but no code detected - opencv");
  }

  @ExceptionHandler(EanDetectedButUnableToReadException.class) public ResponseEntity handleEanReadingError() {
      return ResponseEntity
              .status(HttpStatus.UNPROCESSABLE_ENTITY)
              .body("Item created, code detected but error during read - zxing");
  }
}
